-- name: [CS] Rayman + Globox
-- description: Custom model of Rayman and Globox\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

-- THIS MODEL AND CHARACTER MOD WAS CREATED BY SEYMOUR AND IS NOT PERMITTED FOR RE-USE OR RE-UPLOADING.

local TEXT_MOD_NAME = "Rayman + Globox"

local E_RAYMAN_MODEL = smlua_model_util_get_id("rayman_geo")
local TEX_RAYMAN_ICON = get_texture_info("rayman-icon")

local VOICETABLE_RAYMAN = {
	[CHAR_SOUND_YAH_WAH_HOO]			= { "ray_jump_a", "ray_jump_b", "ray_jump_c" },		-- jump
	[CHAR_SOUND_HOOHOO]					= { "ray_jump2_a", "ray_jump2_b" },		-- double jump
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE]		= { "ray_yahoo", "ray_wahoo" },		-- triple jump variants
	[CHAR_SOUND_YAHOO]					= "ray_wahoo",		-- long jump
	[CHAR_SOUND_UH]						= nil,		-- hit wall by jump
	[CHAR_SOUND_HRMM]					= nil,		-- grab entity
	[CHAR_SOUND_WAH2]					= nil,		-- throw
	[CHAR_SOUND_WHOA]					= nil,		-- ledge grab
	[CHAR_SOUND_EEUH]					= nil,		-- ledge climb
	[CHAR_SOUND_ATTACKED]				= { "ray_damage_a", "ray_damage_b" },		-- hurt noise
	[CHAR_SOUND_OOOF]					= nil,		-- land from hit wall hard
	[CHAR_SOUND_OOOF2]					= nil,		-- exit stage by dying
	[CHAR_SOUND_IMA_TIRED]				= nil,		-- falling asleep
	[CHAR_SOUND_YAWNING]				= nil,		-- falling asleep
	[CHAR_SOUND_SNORING1]				= nil,		-- snoring while asleep (inhale)
	[CHAR_SOUND_SNORING2]				= nil,		-- snoring while asleep (exhale)
	[CHAR_SOUND_SNORING3]				= nil,		-- snoring while asleep (mumbling)
	[CHAR_SOUND_WAAAOOOW]				= nil,		-- fall offstage or from great height
	[CHAR_SOUND_HAHA]					= nil,		-- land triple jump
	[CHAR_SOUND_HAHA_2]					= nil,		-- land triple jump
	[CHAR_SOUND_UH2]					= nil,		-- fast ledge climb (press A)
	[CHAR_SOUND_UH2_2]					= nil,		-- long jump landing (with no landing input)
	[CHAR_SOUND_ON_FIRE]				= nil,		-- set on fire
	[CHAR_SOUND_DYING]					= nil,		-- dying
	[CHAR_SOUND_PANTING_COLD]			= nil,		-- low health pant in cold
	[CHAR_SOUND_PANTING]				= nil,		-- low health pant
	[CHAR_SOUND_COUGHING1]				= nil,		-- hazy maze cave coughs
	[CHAR_SOUND_COUGHING2]				= nil,		-- hazy maze cave coughs
	[CHAR_SOUND_COUGHING3]				= nil,		-- hazy maze cave coughs
	[CHAR_SOUND_PUNCH_YAH]				= "ray_attack_a",		-- attacks [punch]
	[CHAR_SOUND_PUNCH_WAH]				= "ray_attack_b",		-- attacks [second punch]
	[CHAR_SOUND_PUNCH_HOO]				= "ray_attack_c",		-- attacks [kick / speedkick]
	[CHAR_SOUND_MAMA_MIA]				= nil,		-- die outside painting
	[CHAR_SOUND_GROUND_POUND_WAH]		= nil,		-- ground pound sound
	[CHAR_SOUND_DROWNING]				= nil,		-- drowning
	[CHAR_SOUND_DOH]					= nil,		-- hitting a wall hard
	-- [CHAR_SOUND_GAME_OVER]				= nil,		-- game over (unused)
	-- [CHAR_SOUND_HELLO]					= nil,		-- 
	[CHAR_SOUND_PRESS_START_TO_PLAY]	= nil,		-- 
	[CHAR_SOUND_TWIRL_BOUNCE]			= nil,		-- boing!
	[CHAR_SOUND_SO_LONGA_BOWSER]		= nil,		-- bowser throw
	[CHAR_SOUND_HERE_WE_GO]				= nil,		-- collect star / collect key / throw bowser
	[CHAR_SOUND_LETS_A_GO]				= nil,		-- stage selected
	-- [CHAR_SOUND_OKEY_DOKEY]				= nil,		-- 
	-- [CHAR_SOUND_MAX]					= nil,		-- 
}

local CAPTABLE_RAYMAN = {
	normal      = smlua_model_util_get_id("rayman_cap_normal_geo"),
	wing        = smlua_model_util_get_id("rayman_cap_wing_geo"),
	metal       = smlua_model_util_get_id("rayman_cap_metal_geo"),
	metalWing   = smlua_model_util_get_id("rayman_cap_wing_geo"),
}

local E_GLOBOX_MODEL = smlua_model_util_get_id("globox_geo")
local TEX_GLOBOX_ICON = get_texture_info("globox-icon")

local VOICETABLE_GLOBOX = {
	[CHAR_SOUND_YAH_WAH_HOO]			= "globox_hup",		-- jump
	[CHAR_SOUND_HOOHOO]					= "globox_hup",		-- double jump
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE]		= "globox_heehee",		-- triple jump variants
	[CHAR_SOUND_YAHOO]					= "globox_heehee",		-- long jump
	[CHAR_SOUND_UH]						= nil,		-- hit wall by jump
	[CHAR_SOUND_HRMM]					= nil,		-- grab entity
	[CHAR_SOUND_WAH2]					= nil,		-- throw
	[CHAR_SOUND_WHOA]					= nil,		-- ledge grab
	[CHAR_SOUND_EEUH]					= nil,		-- ledge climb
	[CHAR_SOUND_ATTACKED]				= "globox_hurt_a",		-- hurt noise
	[CHAR_SOUND_OOOF]					= nil,		-- land from hit wall hard
	[CHAR_SOUND_OOOF2]					= nil,		-- exit stage by dying
	[CHAR_SOUND_IMA_TIRED]				= nil,		-- falling asleep
	[CHAR_SOUND_YAWNING]				= nil,		-- falling asleep
	[CHAR_SOUND_SNORING1]				= nil,		-- snoring while asleep (inhale)
	[CHAR_SOUND_SNORING2]				= nil,		-- snoring while asleep (exhale)
	[CHAR_SOUND_SNORING3]				= nil,		-- snoring while asleep (mumbling)
	[CHAR_SOUND_WAAAOOOW]				= nil,		-- fall offstage or from great height
	[CHAR_SOUND_HAHA]					= nil,		-- land triple jump
	[CHAR_SOUND_HAHA_2]					= nil,		-- land triple jump
	[CHAR_SOUND_UH2]					= nil,		-- fast ledge climb (press A)
	[CHAR_SOUND_UH2_2]					= nil,		-- long jump landing (with no landing input)
	[CHAR_SOUND_ON_FIRE]				= nil,		-- set on fire
	[CHAR_SOUND_DYING]					= nil,		-- dying
	[CHAR_SOUND_PANTING_COLD]			= nil,		-- low health pant in cold
	[CHAR_SOUND_PANTING]				= nil,		-- low health pant
	[CHAR_SOUND_COUGHING1]				= nil,		-- hazy maze cave coughs
	[CHAR_SOUND_COUGHING2]				= nil,		-- hazy maze cave coughs
	[CHAR_SOUND_COUGHING3]				= nil,		-- hazy maze cave coughs
	[CHAR_SOUND_PUNCH_YAH]				= nil,		-- attacks [punch]
	[CHAR_SOUND_PUNCH_WAH]				= nil,		-- attacks [second punch]
	[CHAR_SOUND_PUNCH_HOO]				= nil,		-- attacks [kick / speedkick]
	[CHAR_SOUND_MAMA_MIA]				= nil,		-- die outside painting
	[CHAR_SOUND_GROUND_POUND_WAH]		= nil,		-- ground pound sound
	[CHAR_SOUND_DROWNING]				= nil,		-- drowning
	[CHAR_SOUND_DOH]					= nil,		-- hitting a wall hard
	[CHAR_SOUND_GAME_OVER]				= nil,		-- game over (unused)
	[CHAR_SOUND_HELLO]					= nil,		-- 
	[CHAR_SOUND_PRESS_START_TO_PLAY]	= nil,		-- 
	[CHAR_SOUND_TWIRL_BOUNCE]			= nil,		-- boing!
	[CHAR_SOUND_SO_LONGA_BOWSER]		= nil,		-- bowser throw
	[CHAR_SOUND_HERE_WE_GO]				= nil,		-- collect star / collect key / throw bowser
	[CHAR_SOUND_LETS_A_GO]				= nil,		-- stage selected
	[CHAR_SOUND_OKEY_DOKEY]				= nil,		-- 
	[CHAR_SOUND_MAX]					= nil,		-- 
}

local CAPTABLE_GLOBOX = {
	normal      = smlua_model_util_get_id("globox_cap_normal_geo"),
	wing        = smlua_model_util_get_id("globox_cap_wing_geo"),
	metal       = smlua_model_util_get_id("globox_cap_metal_geo"),
	metalWing   = smlua_model_util_get_id("globox_cap_wing_geo"),
}


local function add_file_type(table)
    for sound in pairs(table) do
        if (type(table[sound]) == "table") then
            add_file_type(table[sound])
        else
            table[sound] = table[sound]..'.ogg'
        end
    end
end

add_file_type(VOICETABLE_RAYMAN)
add_file_type(VOICETABLE_GLOBOX)

if _G.charSelectExists and SM64COOPDX_VERSION then
    CT_RAYMAN = _G.charSelect.character_add("Rayman", {"no arms. no legs. huge features.",}, "seymour schlong", "981090", E_RAYMAN_MODEL, CT_MARIO, TEX_RAYMAN_ICON)
    _G.charSelect.character_add_caps(E_RAYMAN_MODEL, CAPTABLE_RAYMAN)
    _G.charSelect.character_add_voice(E_RAYMAN_MODEL, VOICETABLE_RAYMAN)

    CT_GLOBOX = _G.charSelect.character_add("Globox", {"father of many. second to none.",}, "seymour schlong", "26ace7", E_GLOBOX_MODEL, CT_MARIO, TEX_GLOBOX_ICON)
    _G.charSelect.character_add_caps(E_GLOBOX_MODEL, CAPTABLE_GLOBOX)
    _G.charSelect.character_add_voice(E_GLOBOX_MODEL, VOICETABLE_GLOBOX)
	
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_RAYMAN then return _G.charSelect.voice.sound(m, sound) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_GLOBOX then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_RAYMAN then return _G.charSelect.voice.snore(m) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_GLOBOX then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end